#ifndef DW_INCLUDE_H
#define DW_INCLUDE_H

/* maximum length for expanded BeginLock strings, and also for
 * the 'orig' part within it. */
#define MAX_LOCK_LEN  1024

#define DW_LOCK_BEGIN_STR "<MM:BeginLock translatorClass=\"WM_XSSI\" uniqid=\"%d\" type=\"%s\" orig=\"%s\">\n"
#define DW_IF_LOCK_BEGIN_STR "<MM:BeginLock translatorClass=\"WM_XSSI\" uniqid=\"%d\" type=\"%s\" printing=\"%d\" orig=\"%s\">\n"
#define DW_SEMI_IF_LOCK_BEGIN_STR "<MM:BeginLock translatorClass=\"WM_XSSI\" uniqid=\"%d\" type=\"%s\" printing=\"%d\" orig=\"%s"
#define DW_SEMI_LOCK_END_STR "\">\n%s<MM:EndLock>"
#define DW_LOCK_END_STR "\n<MM:EndLock>"

#define DW_SET_INVIS    "<!-- xssi 'set' translated -->"
#define DW_IF_INVIS     "<!-- xssi 'if' translated -->"
#define DW_ELIF_INVIS   "<!-- xssi 'elif' translated -->"
#define DW_ELSE_INVIS   "<!-- xssi 'else' translated -->"
#define DW_ENDIF_INVIS  "<!-- xssi 'endif' translated -->"

#define DW_ECHO_TYPE      "xssi_echo"
#define DW_SET_TYPE       "xssi_set"
#define DW_PRINTENV_TYPE  "xssi_printenv"
#define DW_INCLUDE_TYPE   "xssi_include"
#define DW_IF_TYPE        "xssi_if"
#define DW_ELIF_TYPE      "xssi_elif"
#define DW_ELSE_TYPE      "xssi_else"
#define DW_ENDIF_TYPE     "xssi_endif"

#define DW_ECHO_ORIG      "<!--#echo var=\"%s\" -->"
#define DW_SET_ORIG       "<!--#set var=\"%s\" value=\"%s\" -->"
#define DW_PRINTENV_ORIG  "<!--#printenv -->"
#define DW_VINCLUDE_ORIG  "<!--#include virtual=\"%s\" -->"
#define DW_FINCLUDE_ORIG  "<!--#include file=\"%s\" -->"
#define DW_IF_ORIG        "<!--#if expr=\"%s\" -->"
#define DW_ELIF_ORIG      "<!--#elif expr=\"%s\" -->"
#define DW_ELSE_ORIG      "<!--#else -->"
#define DW_ENDIF_ORIG     "<!--#endif -->"

#ifdef TAYLOR_WANTS_XML
#define DW_SET_XML        "<XSSISET>"
#define DW_IF_XML         "<XSSIIF>"
#define DW_ELIF_XML       "<XSSIELIF>"
#define DW_ELSE_XML       "<XSSIELSE>"
#define DW_ENDIF_XML      "<XSSIENDIF>"
#else
#define DW_SET_XML        DW_SET_INVIS
#define DW_IF_XML         DW_IF_INVIS
#define DW_ELIF_XML       DW_ELIF_INVIS
#define DW_ELSE_XML       DW_ELSE_INVIS
#define DW_ENDIF_XML      DW_ENDIF_INVIS
#endif /* TAYLOR_WANTS_XML */

enum dw_current_tag {
	xssi_none = 0,
	xssi_if,
	xssi_elif,
	xssi_else,
	xssi_endif
};

char *dw_current_tag_str(int);

void dw_print_echo(request_rec *r, const char *tag, const char *val, int count);
void dw_print_set(request_rec *r, const char *tag, const char *val,
									const char *val_orig, int count);
void dw_print_printenv(request_rec *r, const char *env, int count);

void dw_print_vinclude_head(request_rec *r, const char *fname, int count);
void dw_print_finclude_head(request_rec *r, const char *fname, int count);
void dw_print_include_tail(request_rec *r);

void dw_print_if(request_rec *r, const char *expr, int status, int current_tag,
								 int count);
void dw_print_elif(request_rec *r, const char *expr, int status,
									 int just_printed, int current_tag,
									 dw_strbuff *savebuff, int count);
void dw_print_else(request_rec *r, int printing, int just_printed,
									 int current_tag, dw_strbuff *savebuff, int count);
void dw_print_endif(request_rec *r, int printing, int current_tag,
										dw_strbuff *savebuff, int count);

char *dw_escape_quotes(pool *pool, const char *orig);
char *dw_mini_escape(pool *pool, const char *orig);

#endif /* DW_INCLUDE_H */
