#include <stdio.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "httpd.h"
#include "alloc.h"
#include "main.h"
#include "buff.h"
#include "mm_jsapi.h"
#include "xs.h"

#define ENV_ENTRIES 15
#define MAX_BUFF_SIZE 8192

#define MM_STATE

MM_EXPORT JSBool translate_markup(JSContext *cx, JSObject *obj,
																	unsigned int argc,
																	jsval *argv, jsval *rval)
{
	char *out = "<MM:BeginLock translatorClass=\"MM_alx\" type=\"alx\" orig=\"\">\nhi there\n<MM:EndLock>";
	JSBool ret = JS_StringToValue(cx, out, 0, rval);

	return ret;
	//return JS_TRUE;
}

API_EXPORT(void) MM_Init()
{
	JS_DefineFunction("translate_markup", translate_markup, 3);
}

 main(int argc, char **argv) {
	time_t now;
	FILE *in;
	int out;
	pool *main_pool;
	request_rec *r;
	conn_rec *c;
	server_rec *s;
	BUFF *buff;
	char *file_data, *read_ptr;
	int i;
	
	printf("hello\n");
	
	load_funcs();


	/* open files */
	if ((in = fopen("/alx/dream/test.html", "r")) == NULL) {
		show_error_and_exit("opening test.html");
	}

	if ((out = open("out.html", O_CREAT | O_RDWR, S_IWRITE)) == -1) {
		show_error_and_exit("opening out.html");
	}

	/* get us some memory */
	/* XXX these should probably use ap_pcalloc or something */
	if ((r = (request_rec *)malloc(sizeof(request_rec *))) == NULL) {
		show_error_and_exit("malloc request_rec");
	}

	if ((c = (conn_rec *)malloc(sizeof(conn_rec *))) == NULL) {
		show_error_and_exit("malloc conn_rec");
	}

	if ((s = (server_rec *)malloc(sizeof(server_rec *))) == NULL) {
		show_error_and_exit("malloc server_rec");
	}

	if ((file_data = (char *)malloc(MAX_BUFF_SIZE * sizeof(char *))) == NULL) {
		show_error_and_exit("malloc file_data");
	}

	/* read in file */
	read_ptr = file_data;
	while ((i = getc(in)) != EOF)
		*(read_ptr++) = (char)i;
	
	*read_ptr = '\0';

	if (ferror(in))
		show_error_and_exit("error reading in");

	fprintf(stdout, "read:\n%s", file_data);
	
	main_pool = make_sub_pool(NULL);
	if (setup_mod(main_pool)) {
		show_error_and_exit("setting up module");
	}
		
	buff = bcreate(main_pool, B_WR);

	/* setup request */
	time(&now);
	
	buff->fd = out;
	c->client = buff;
	c->aborted = 0;

	s->ap_document_root = "/apache/htdocs/dude";
	s->path = "/alx";
	s->pathlen = strlen("/alx");

	r->server = s;
	r->filename = "/alx/test.html";
	r->uri = "/alx/test.html";
	r->pool = make_sub_pool(main_pool);
	r->subprocess_env = make_table(r->pool, ENV_ENTRIES);
	r->notes = make_table(r->pool, ENV_ENTRIES);
	r->connection = c;
	r->request_time = now;
	r->mtime = now;
	r->method = "GET";
	r->method_number = M_GET;
	r->args = "foo";
	r->file_data = file_data;

	/* do it to it */
	parse_content(NULL, r);

	if (bflush(c->client))
		show_error_and_exit("flushing");

	FreeLibrary(hDLL);

	fclose(in);
	close(out);
		
	return 0;
}

/* initialization stuff.  should be called before trying to
 * do any real work.  you think i'm kidding!  -alx
 */
int setup_mod_include(pool *p)
{
    includes_init_handlers(p);
    return 0;
}

int load_funcs()
{
	if ((hDLL = LoadLibrary("xs")) == NULL)
		show_error_and_exit("loading shared lib");
		
	parse_content = (parsefunc)GetProcAddress(hDLL, "send_parsed_content");
	make_sub_pool = (makepoolfunc)GetProcAddress(hDLL, "ap_make_sub_pool");
	make_table = (maketablefunc)GetProcAddress(hDLL, "ap_make_table");
	bcreate = (makebuff)GetProcAddress(hDLL, "ap_bcreate");
	bflush = (flushfunc)GetProcAddress(hDLL, "ap_bflush");
	setup_mod = (setupfunc)GetProcAddress(hDLL, "setup_mod_include");
	if (!parse_content ||
			!make_sub_pool ||
			!make_table ||
			!bcreate ||
			!bflush ||
			!setup_mod)
		{
			/* handle the error */
			FreeLibrary(hDLL);
			show_error_and_exit("loading functions");
		}

	fprintf(stdout, "all loaded!\n");
	return 0;
}

void show_error_and_exit(char *msg)
{
	LPVOID lpMsgBuf;

	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
								NULL,
								GetLastError(),
								MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
								(LPTSTR) &lpMsgBuf,
								0,
								NULL);
	fprintf(stderr, "%s: %s (%d)\n", msg, lpMsgBuf, GetLastError());
	LocalFree(lpMsgBuf);

	exit(-1);
}
